Subject: Re: bug#55199: 28.1; rcirc auth-source integration doesn't handle port being a number

From: Javier Olaechea <[email-masked]>
Date: Sun, 21 Aug 2022 14:02:21 -0500

Hi Michael,

I can confirm patch fixes the issue. I don't think we need to change the
create function. The issue is that a valid spec, meant for another backend,
results in an error when searching the secrets backend.

An alternative solution would be for auth-source-secrets-search to return
an empty list (no secrets found iirc) when the spec contains a non-string
value.

On Sun, Aug 21, 2022 at 3:02 AM Michael Albinus <[email-masked]>
wrote:

> Javier Olaechea <[email-masked]> writes:
>
> Hi Javier,
>
> > I have a simple way to reproduce the issue. Start emacs with emacs -Q.
> > Then evaluate the following snippet
> >
> > (require 'auth-source)
> >
> > (let ((auth-sources '("secrets:Login")))
> >   (auth-source-search :port 6697))
>
> Yep. Fails here as well.
>
> > So the issue is not at all on rcirc, but that secrets backend assumes
> > that the search specs should be strings. I haven't researched the
> > SecretService API to know if this is a restriction of the underlying
> > dbus service the secrets backend works with or just a restrictive
> > assumption of the code in secrets.el.
>
> The Secret Service API allows only strings for attribute keys and
> values, see <
> https://specifications.freedesktop.org/secret-service/latest/re03.html>:
>
> --8<---------------cut here---------------start------------->8---
> READWRITE Dict<String,String> Attributes ;
> --8<---------------cut here---------------end--------------->8---
>
> Looking at auth-source.el. there was a similar problem in
> auth-source-plstore-search, see commit
> fcb89237d9ab969bcd29bf8f8fae8d9905644b92 in Emacs git. Applying a
> similar change to auth-source-secrets-search let the error go away.
>
> I've appended the patch, could you pls check in the rcirc context? I'm
> also not sure whether we need to change something when creating an item
> in auth-source-secrets-create.
>
> Best regrads, Michael.
>
>

-- 
"I object to doing things that computers can do." — Olin Shivers